Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# vtkImageMarchingCubes Class Reference

`#include <vtkImageMarchingCubes.h>`

Inheritance diagram for vtkImageMarchingCubes:

[legend]
Collaboration diagram for vtkImageMarchingCubes:

[legend]
List of all members.

## Detailed Description

generate isosurface(s) from volume/images

Date:
  2002/08/30 21:05:16

Revision:
  1.36

vtkImageMarchingCubes is a filter that takes as input images (e.g., 3D image region) and generates on output one or more isosurfaces. One or more contour values must be specified to generate the isosurfaces. Alternatively, you can specify a min/max scalar range and the number of contours to generate a series of evenly spaced contour values. This filter can stream, so that the entire volume need not be loaded at once. Streaming is controlled using the instance variable InputMemoryLimit, which has units KBytes.

Warning:
  This filter is specialized to volumes. If you are interested in contouring other types of data, use the general vtkContourFilter. If you want to contour an image (i.e., a volume slice), use vtkMarchingSquares.

See also:
  vtkContourFilter vtkSliceCubes vtkMarchingSquares vtkDividingCubes

Events:
  vtkCommand::StartEvent vtkCommand::EndEvent

Created by:
  - Law, Charles

CVS contributions (if > 5%):
  - Law, Charles (66%)
  - Lorensen, Bill (8%)
  - Schroeder, Will (7%)
  - Martin, Ken (6%)

CVS logs (CVSweb):
  - .`h` (`/Patented/vtkImageMarchingCubes.h)`
  - .`cxx` (`/Patented/vtkImageMarchingCubes.cxx)`

Tests:
  vtkImageMarchingCubes (Tests)

Definition at line 85 of file vtkImageMarchingCubes.h.

## Public Types
typedef vtkPolyDataSource | Superclass
## Public Methods
virtual const char * | GetClassName ()
virtual int | IsA (const char *type)
void | PrintSelf (ostream &os, vtkIndent indent)
void | SetValue (int i, float value)
void | GetValues (float *contourValues)
void | SetNumberOfContours (int number)
unsigned long int | GetMTime ()
int | GetLocatorPoint (int cellX, int cellY, int edge)
void | AddLocatorPoint (int cellX, int cellY, int edge, int ptId)
void | IncrementLocatorZ ()
void | Update ()
void | SetInput (vtkImageData *input)
vtkImageData * | GetInput ()
float | GetValue (int i)
float * | GetValues ()
int | GetNumberOfContours ()
void | GenerateValues (int numContours, float range[2])
void | GenerateValues (int numContours, float rangeStart, float rangeEnd)
virtual void | SetComputeScalars (int)
virtual int | GetComputeScalars ()
virtual void | ComputeScalarsOn ()
virtual void | ComputeScalarsOff ()
virtual void | SetComputeNormals (int)
virtual int | GetComputeNormals ()
virtual void | ComputeNormalsOn ()
virtual void | ComputeNormalsOff ()
virtual void | SetComputeGradients (int)
virtual int | GetComputeGradients ()
virtual void | ComputeGradientsOn ()
virtual void | ComputeGradientsOff ()
virtual void | SetInputMemoryLimit (int)
virtual int | GetInputMemoryLimit ()
## Static Public Methods
vtkImageMarchingCubes * | New ()
int | IsTypeOf (const char *type)
vtkImageMarchingCubes * | SafeDownCast (vtkObject *o)
## Public Attributes
int | ComputeScalars
int | ComputeNormals
int | ComputeGradients
int | NeedGradients
vtkCellArray * | Triangles
vtkFloatArray * | Scalars
vtkPoints * | Points
vtkFloatArray * | Normals
vtkFloatArray * | Gradients
## Protected Methods
| vtkImageMarchingCubes ()
| ~vtkImageMarchingCubes ()
void | Execute ()
void | March (vtkImageData *inData, int chunkMin, int chunkMax, int numContours, float *values)
void | InitializeLocator (int min0, int max0, int min1, int max1)
void | DeleteLocator ()
int * | GetLocatorPointer (int cellX, int cellY, int edge)
## Protected Attributes
int | NumberOfSlicesPerChunk
int | InputMemoryLimit
vtkContourValues * | ContourValues
int * | LocatorPointIds
int | LocatorDimX
int | LocatorDimY
int | LocatorMinX
int | LocatorMinY

## Member Typedef Documentation

typedef vtkPolyDataSource vtkImageMarchingCubes::Superclass

| Reimplemented from vtkPolyDataSource. Definition at line 89 of file vtkImageMarchingCubes.h.

## Constructor & Destructor Documentation

vtkImageMarchingCubes::vtkImageMarchingCubes | ( |  | ) | `[protected]`

vtkImageMarchingCubes::~vtkImageMarchingCubes | ( |  | ) | `[protected]`

## Member Function Documentation

vtkImageMarchingCubes* vtkImageMarchingCubes::New | ( |  | ) | `[static]`

| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. Reimplemented from vtkObject.

virtual const char* vtkImageMarchingCubes::GetClassName | ( |  | ) | `[virtual]`

| Reimplemented from vtkPolyDataSource.

int vtkImageMarchingCubes::IsTypeOf | ( | const char * | type | ) | `[static]`

| Return 1 if this class type is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkPolyDataSource.

virtual int vtkImageMarchingCubes::IsA | ( | const char * | type | ) | `[virtual]`

| Return 1 if this class is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkPolyDataSource.

vtkImageMarchingCubes* vtkImageMarchingCubes::SafeDownCast | ( | vtkObject * | o | ) | `[static]`

| Reimplemented from vtkPolyDataSource.

void vtkImageMarchingCubes::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) | `[virtual]`

| Methods invoked by print to print information about the object including superclasses. Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes. Reimplemented from vtkPolyDataSource.

void vtkImageMarchingCubes::SetInput | ( | vtkImageData * | input | ) |

| Set/Get the source for the scalar data to contour.

vtkImageData* vtkImageMarchingCubes::GetInput | ( |  | ) |

| Set/Get the source for the scalar data to contour.

void vtkImageMarchingCubes::SetValue | ( | int | i,
|  | float | value
| ) | `[inline]`

| Set a particular contour value at contour number i. The index i ranges between 0<=i<NumberOfContours. Definition at line 195 of file vtkImageMarchingCubes.h. References ContourValues, and vtkContourValues::SetValue().

float vtkImageMarchingCubes::GetValue | ( | int | i | ) | `[inline]`

| Get the ith contour value. Definition at line 200 of file vtkImageMarchingCubes.h. References ContourValues, and vtkContourValues::GetValue().

float * vtkImageMarchingCubes::GetValues | ( |  | ) | `[inline]`

| Get a pointer to an array of contour values. There will be GetNumberOfContours() values in the list. Definition at line 207 of file vtkImageMarchingCubes.h. References ContourValues, and vtkContourValues::GetValues().

void vtkImageMarchingCubes::GetValues | ( | float * | contourValues | ) | `[inline]`

| Fill a supplied list with contour values. There will be GetNumberOfContours() values in the list. Make sure you allocate enough memory to hold the list. Definition at line 214 of file vtkImageMarchingCubes.h. References ContourValues, and vtkContourValues::GetValues().

void vtkImageMarchingCubes::SetNumberOfContours | ( | int | number | ) | `[inline]`

| Set the number of contours to place into the list. You only really need to use this method to reduce list size. The method SetValue() will automatically increase list size as needed. Definition at line 220 of file vtkImageMarchingCubes.h. References ContourValues, and vtkContourValues::SetNumberOfContours().

int vtkImageMarchingCubes::GetNumberOfContours | ( |  | ) | `[inline]`

| Get the number of contours in the list of contour values. Definition at line 225 of file vtkImageMarchingCubes.h. References ContourValues, and vtkContourValues::GetNumberOfContours().

void vtkImageMarchingCubes::GenerateValues | ( | int | numContours,
|  | float | range[2]
| ) | `[inline]`

| Generate numContours equally spaced contour values between specified range. Contour values will include min/max range values. Definition at line 232 of file vtkImageMarchingCubes.h. References ContourValues, and vtkContourValues::GenerateValues().

void vtkImageMarchingCubes::GenerateValues | ( | int | numContours,
|  | float | rangeStart,
|  | float | rangeEnd
| ) | `[inline]`

| Generate numContours equally spaced contour values between specified range. Contour values will include min/max range values. Definition at line 239 of file vtkImageMarchingCubes.h. References ContourValues, and vtkContourValues::GenerateValues().

unsigned long int vtkImageMarchingCubes::GetMTime | ( |  | ) | `[virtual]`

| Return this object's modified time. Reimplemented from vtkObject.

virtual void vtkImageMarchingCubes::SetComputeScalars | ( | int |  | ) | `[virtual]`

| Set/Get the computation of scalars.

virtual int vtkImageMarchingCubes::GetComputeScalars | ( |  | ) | `[virtual]`

| Set/Get the computation of scalars.

virtual void vtkImageMarchingCubes::ComputeScalarsOn | ( |  | ) | `[virtual]`

| Set/Get the computation of scalars.

virtual void vtkImageMarchingCubes::ComputeScalarsOff | ( |  | ) | `[virtual]`

| Set/Get the computation of scalars.

virtual void vtkImageMarchingCubes::SetComputeNormals | ( | int |  | ) | `[virtual]`

| Set/Get the computation of normals. Normal computation is fairly expensive in both time and storage. If the output data will be processed by filters that modify topology or geometry, it may be wise to turn Normals and Gradients off.

virtual int vtkImageMarchingCubes::GetComputeNormals | ( |  | ) | `[virtual]`

| Set/Get the computation of normals. Normal computation is fairly expensive in both time and storage. If the output data will be processed by filters that modify topology or geometry, it may be wise to turn Normals and Gradients off.

virtual void vtkImageMarchingCubes::ComputeNormalsOn | ( |  | ) | `[virtual]`

| Set/Get the computation of normals. Normal computation is fairly expensive in both time and storage. If the output data will be processed by filters that modify topology or geometry, it may be wise to turn Normals and Gradients off.

virtual void vtkImageMarchingCubes::ComputeNormalsOff | ( |  | ) | `[virtual]`

| Set/Get the computation of normals. Normal computation is fairly expensive in both time and storage. If the output data will be processed by filters that modify topology or geometry, it may be wise to turn Normals and Gradients off.

virtual void vtkImageMarchingCubes::SetComputeGradients | ( | int |  | ) | `[virtual]`

| Set/Get the computation of gradients. Gradient computation is fairly expensive in both time and storage. Note that if ComputeNormals is on, gradients will have to be calculated, but will not be stored in the output dataset. If the output data will be processed by filters that modify topology or geometry, it may be wise to turn Normals and Gradients off.

virtual int vtkImageMarchingCubes::GetComputeGradients | ( |  | ) | `[virtual]`

| Set/Get the computation of gradients. Gradient computation is fairly expensive in both time and storage. Note that if ComputeNormals is on, gradients will have to be calculated, but will not be stored in the output dataset. If the output data will be processed by filters that modify topology or geometry, it may be wise to turn Normals and Gradients off.

virtual void vtkImageMarchingCubes::ComputeGradientsOn | ( |  | ) | `[virtual]`

| Set/Get the computation of gradients. Gradient computation is fairly expensive in both time and storage. Note that if ComputeNormals is on, gradients will have to be calculated, but will not be stored in the output dataset. If the output data will be processed by filters that modify topology or geometry, it may be wise to turn Normals and Gradients off.

virtual void vtkImageMarchingCubes::ComputeGradientsOff | ( |  | ) | `[virtual]`

| Set/Get the computation of gradients. Gradient computation is fairly expensive in both time and storage. Note that if ComputeNormals is on, gradients will have to be calculated, but will not be stored in the output dataset. If the output data will be processed by filters that modify topology or geometry, it may be wise to turn Normals and Gradients off.

int vtkImageMarchingCubes::GetLocatorPoint | ( | int | cellX,
|  | int | cellY,
|  | int | edge
| ) |

void vtkImageMarchingCubes::AddLocatorPoint | ( | int | cellX,
|  | int | cellY,
|  | int | edge,
|  | int | ptId
| ) |

void vtkImageMarchingCubes::IncrementLocatorZ | ( |  | ) |

void vtkImageMarchingCubes::Update | ( |  | ) | `[virtual]`

| Bring object up-to-date before execution. Update() checks modified time against last execution time, and re-executes object if necessary. Reimplemented from vtkSource.

virtual void vtkImageMarchingCubes::SetInputMemoryLimit | ( | int |  | ) | `[virtual]`

| The InputMemoryLimit determines the chunk size (the number of slices requested at each iteration). The units of this limit is KiloBytes. For now, only the Z axis is split.

virtual int vtkImageMarchingCubes::GetInputMemoryLimit | ( |  | ) | `[virtual]`

| The InputMemoryLimit determines the chunk size (the number of slices requested at each iteration). The units of this limit is KiloBytes. For now, only the Z axis is split.

void vtkImageMarchingCubes::Execute | ( |  | ) | `[protected, virtual]`

| This method is the old style execute method Reimplemented from vtkSource.

void vtkImageMarchingCubes::March | ( | vtkImageData * | inData,
|  | int | chunkMin,
|  | int | chunkMax,
|  | int | numContours,
|  | float * | values
| ) | `[protected]`

void vtkImageMarchingCubes::InitializeLocator | ( | int | min0,
|  | int | max0,
|  | int | min1,
|  | int | max1
| ) | `[protected]`

void vtkImageMarchingCubes::DeleteLocator | ( |  | ) | `[protected]`

int* vtkImageMarchingCubes::GetLocatorPointer | ( | int | cellX,
|  | int | cellY,
|  | int | edge
| ) | `[protected]`

## Member Data Documentation

int vtkImageMarchingCubes::ComputeScalars

| Definition at line 141 of file vtkImageMarchingCubes.h.

int vtkImageMarchingCubes::ComputeNormals

| Definition at line 142 of file vtkImageMarchingCubes.h.

int vtkImageMarchingCubes::ComputeGradients

| Definition at line 143 of file vtkImageMarchingCubes.h.

int vtkImageMarchingCubes::NeedGradients

| Definition at line 144 of file vtkImageMarchingCubes.h.

vtkCellArray* vtkImageMarchingCubes::Triangles

| Definition at line 146 of file vtkImageMarchingCubes.h.

vtkFloatArray* vtkImageMarchingCubes::Scalars

| Definition at line 147 of file vtkImageMarchingCubes.h.

vtkPoints* vtkImageMarchingCubes::Points

| Definition at line 148 of file vtkImageMarchingCubes.h.

vtkFloatArray* vtkImageMarchingCubes::Normals

| Definition at line 149 of file vtkImageMarchingCubes.h.

vtkFloatArray* vtkImageMarchingCubes::Gradients

| Definition at line 150 of file vtkImageMarchingCubes.h.

int vtkImageMarchingCubes::NumberOfSlicesPerChunk`[protected]`

| Definition at line 170 of file vtkImageMarchingCubes.h.

int vtkImageMarchingCubes::InputMemoryLimit`[protected]`

| Definition at line 171 of file vtkImageMarchingCubes.h.

vtkContourValues* vtkImageMarchingCubes::ContourValues`[protected]`

| Definition at line 173 of file vtkImageMarchingCubes.h. Referenced by GenerateValues(), GetNumberOfContours(), GetValue(), GetValues(), SetNumberOfContours(), and SetValue().

int* vtkImageMarchingCubes::LocatorPointIds`[protected]`

| Definition at line 175 of file vtkImageMarchingCubes.h.

int vtkImageMarchingCubes::LocatorDimX`[protected]`

| Definition at line 176 of file vtkImageMarchingCubes.h.

int vtkImageMarchingCubes::LocatorDimY`[protected]`

| Definition at line 177 of file vtkImageMarchingCubes.h.

int vtkImageMarchingCubes::LocatorMinX`[protected]`

| Definition at line 178 of file vtkImageMarchingCubes.h.

int vtkImageMarchingCubes::LocatorMinY`[protected]`

| Definition at line 179 of file vtkImageMarchingCubes.h.

The documentation for this class was generated from the following file:

- Patented/vtkImageMarchingCubes.h